SET client_encoding = 'UTF8';
SET standard_conforming_strings = off;
SET check_function_bodies = false;
SET client_min_messages = warning;
SET escape_string_warning = off;

SET search_path = setting, log, pg_catalog;

CREATE OR REPLACE FUNCTION add_cc_cfg_xcloud_platform( varchar, varchar, varchar ) RETURNS VOID AS
$$
BEGIN
	SET search_path = setting, log, pg_catalog;
	UPDATE cc_cfg_xcloud_platform SET cloud_platform_name=$2, description=$3 WHERE cloud_platform_id=$1;
	INSERT INTO cc_cfg_xcloud_platform (cloud_platform_id, cloud_platform_name, description)
		SELECT $1, $2, $3 WHERE NOT EXISTS (SELECT 1 FROM cc_cfg_xcloud_platform WHERE cloud_platform_id=$1);
END
$$ LANGUAGE plpgsql;

SELECT add_cc_cfg_xcloud_platform('AZURE','Microsoft Azure','http://azure.microsoft.com/ja-jp/');

DROP FUNCTION add_cc_cfg_xcloud_platform( varchar, varchar, varchar );


CREATE OR REPLACE FUNCTION add_cc_collector_platform_mst( varchar, varchar, integer ) RETURNS VOID AS
$$
BEGIN
	SET search_path = setting, log, pg_catalog;
	UPDATE cc_collector_platform_mst SET platform_name=$2, order_no=$3 WHERE platform_id=$1;
	INSERT INTO cc_collector_platform_mst (platform_id, platform_name, order_no)
		SELECT $1, $2, $3 WHERE NOT EXISTS (SELECT 1 FROM cc_collector_platform_mst WHERE platform_id=$1);
END
$$ LANGUAGE plpgsql;

SELECT add_cc_collector_platform_mst('AZURE','Microsoft Azure',111);

DROP FUNCTION add_cc_collector_platform_mst( varchar, varchar, integer );


CREATE OR REPLACE FUNCTION add_cc_collector_sub_platform_mst( varchar, varchar, varchar, integer ) RETURNS VOID AS
$$
BEGIN
	SET search_path = setting, log, pg_catalog;
	UPDATE cc_collector_sub_platform_mst SET sub_platform_name=$2, type=$3, order_no=$4 WHERE sub_platform_id=$1;
	INSERT INTO cc_collector_sub_platform_mst (sub_platform_id, sub_platform_name, type, order_no)
		SELECT $1, $2, $3, $4 WHERE NOT EXISTS (SELECT 1 FROM cc_collector_sub_platform_mst WHERE sub_platform_id=$1);
END
$$ LANGUAGE plpgsql;

SELECT add_cc_collector_sub_platform_mst('AZURE','Microsoft Azure','Cloud',111);

DROP FUNCTION add_cc_collector_sub_platform_mst( varchar, varchar, varchar, integer );

SET search_path = setting, log, pg_catalog;
CREATE OR REPLACE FUNCTION add_cc_cfg_xcloud_platform( varchar, varchar, varchar ) RETURNS VOID AS
$$
BEGIN
	SET search_path = setting, log, pg_catalog;
	UPDATE cc_cfg_xcloud_platform SET cloud_platform_name=$2, description=$3 WHERE cloud_platform_id=$1;
	INSERT INTO cc_cfg_xcloud_platform (cloud_platform_id, cloud_platform_name, description)
		SELECT $1, $2, $3 WHERE NOT EXISTS (SELECT 1 FROM cc_cfg_xcloud_platform WHERE cloud_platform_id=$1);
END
$$ LANGUAGE plpgsql;

SELECT add_cc_cfg_xcloud_platform('AZURE','Microsoft Azure','http://azure.microsoft.com/ja-jp/');

DROP FUNCTION add_cc_cfg_xcloud_platform( varchar, varchar, varchar );


CREATE OR REPLACE FUNCTION add_cc_collector_platform_mst( varchar, varchar, integer ) RETURNS VOID AS
$$
BEGIN
	SET search_path = setting, log, pg_catalog;
	UPDATE cc_collector_platform_mst SET platform_name=$2, order_no=$3 WHERE platform_id=$1;
	INSERT INTO cc_collector_platform_mst (platform_id, platform_name, order_no)
		SELECT $1, $2, $3 WHERE NOT EXISTS (SELECT 1 FROM cc_collector_platform_mst WHERE platform_id=$1);
END
$$ LANGUAGE plpgsql;

SELECT add_cc_collector_platform_mst('AZURE','Microsoft Azure',111);

DROP FUNCTION add_cc_collector_platform_mst( varchar, varchar, integer );


CREATE OR REPLACE FUNCTION add_cc_collector_sub_platform_mst( varchar, varchar, varchar, integer ) RETURNS VOID AS
$$
BEGIN
	SET search_path = setting, log, pg_catalog;
	UPDATE cc_collector_sub_platform_mst SET sub_platform_name=$2, type=$3, order_no=$4 WHERE sub_platform_id=$1;
	INSERT INTO cc_collector_sub_platform_mst (sub_platform_id, sub_platform_name, type, order_no)
		SELECT $1, $2, $3, $4 WHERE NOT EXISTS (SELECT 1 FROM cc_collector_sub_platform_mst WHERE sub_platform_id=$1);
END
$$ LANGUAGE plpgsql;

SELECT add_cc_collector_sub_platform_mst('AZURE','Microsoft Azure','Cloud',111);

DROP FUNCTION add_cc_collector_sub_platform_mst( varchar, varchar, varchar, integer );

CREATE OR REPLACE FUNCTION add_cc_collector_category_collect_mst( varchar, varchar, varchar, varchar ) RETURNS VOID AS
$$
BEGIN
	SET search_path = setting, log, pg_catalog;
	UPDATE cc_collector_category_collect_mst SET collect_method=$4 WHERE platform_id=$1 AND sub_platform_id=$2 AND category_code=$3;
	INSERT INTO cc_collector_category_collect_mst (platform_id, sub_platform_id, category_code, collect_method)
		SELECT $1, $2, $3, $4 WHERE NOT EXISTS (SELECT 1 FROM cc_collector_category_collect_mst WHERE platform_id=$1 AND sub_platform_id=$2 AND category_code=$3);
END
$$ LANGUAGE plpgsql;

SELECT add_cc_collector_category_collect_mst('LINUX','AZURE','C000_CPU','SNMP');
SELECT add_cc_collector_category_collect_mst('LINUX','AZURE','C001_MEM','SNMP');
SELECT add_cc_collector_category_collect_mst('LINUX','AZURE','C002_DSK','SNMP');
SELECT add_cc_collector_category_collect_mst('LINUX','AZURE','C003_NET','SNMP');
SELECT add_cc_collector_category_collect_mst('WINDOWS','AZURE','C020_CPU','SNMP');
SELECT add_cc_collector_category_collect_mst('WINDOWS','AZURE','C021_MEM','SNMP');
SELECT add_cc_collector_category_collect_mst('WINDOWS','AZURE','C022_DSK','SNMP');
SELECT add_cc_collector_category_collect_mst('WINDOWS','AZURE','C023_NET','SNMP');

DROP FUNCTION add_cc_collector_category_collect_mst( varchar, varchar, varchar, varchar );

CREATE OR REPLACE FUNCTION add_cc_collector_item_calc_method_mst( varchar, varchar , varchar ) RETURNS VOID AS
$$
BEGIN
	SET search_path = setting, log, pg_catalog;
	UPDATE cc_collector_item_calc_method_mst AS OM
		SET calc_method =(SELECT calc_method FROM cc_collector_item_calc_method_mst WHERE  collect_method=OM.collect_method AND platform_id=OM.platform_id AND sub_platform_id='' AND item_code=OM.item_code)
	WHERE 
		OM.platform_id=$2 AND
		OM.sub_platform_id=$3 AND
		EXISTS (SELECT 1 FROM cc_collector_item_calc_method_mst WHERE collect_method=OM.collect_method AND platform_id=OM.platform_id AND sub_platform_id=OM.sub_platform_id AND item_code=OM.item_code);
	INSERT INTO cc_collector_item_calc_method_mst (collect_method, platform_id, sub_platform_id, item_code, calc_method)
		SELECT IM.collect_method, IM.platform_id, $3, IM.item_code, IM.calc_method FROM cc_collector_item_calc_method_mst IM
		WHERE NOT EXISTS (SELECT 1 FROM cc_collector_item_calc_method_mst WHERE collect_method=IM.collect_method AND platform_id=IM.platform_id AND sub_platform_id=$3 AND item_code=IM.item_code) AND
			IM.collect_method=$1 AND IM.platform_id=$2;
END
$$ LANGUAGE plpgsql;

SELECT add_cc_collector_item_calc_method_mst('SNMP', 'LINUX' , 'AZURE');
SELECT add_cc_collector_item_calc_method_mst('SNMP', 'WINDOWS' ,'AZURE');

DROP FUNCTION add_cc_collector_item_calc_method_mst( varchar, varchar , varchar);

CREATE OR REPLACE FUNCTION add_cc_collector_polling_mst( varchar, varchar, varchar ) RETURNS VOID AS
$$
BEGIN
	SET search_path = setting, log, pg_catalog;
	UPDATE cc_collector_polling_mst AS OM
		SET
			entry_key=(SELECT entry_key FROM cc_collector_polling_mst WHERE collect_method=OM.collect_method AND platform_id=OM.platform_id AND sub_platform_id='' AND item_code=OM.item_code AND variable_id=OM.variable_id),
			value_type=(SELECT value_type FROM cc_collector_polling_mst WHERE collect_method=OM.collect_method AND platform_id=OM.platform_id AND sub_platform_id='' AND item_code=OM.item_code AND variable_id=OM.variable_id),
			polling_target=(SELECT polling_target FROM cc_collector_polling_mst WHERE collect_method=OM.collect_method AND platform_id=OM.platform_id AND sub_platform_id='' AND item_code=OM.item_code AND variable_id=OM.variable_id),
			failure_value=(SELECT failure_value FROM cc_collector_polling_mst WHERE collect_method=OM.collect_method AND platform_id=OM.platform_id AND sub_platform_id='' AND item_code=OM.item_code AND variable_id=OM.variable_id)
	WHERE 
		OM.collect_method=$1 AND OM.platform_id=$2 AND OM.sub_platform_id=$3 AND
		EXISTS (SELECT 1 FROM cc_collector_polling_mst WHERE collect_method=OM.collect_method AND platform_id=OM.platform_id AND sub_platform_id=OM.sub_platform_id AND item_code=OM.item_code AND variable_id=OM.variable_id);

	INSERT INTO cc_collector_polling_mst (collect_method, platform_id, sub_platform_id, item_code, variable_id, entry_key, value_type, polling_target, failure_value)
		SELECT IM.collect_method, IM.platform_id, $3, IM.item_code, IM.variable_id, IM.entry_key, IM.value_type, IM.polling_target, IM.failure_value
			FROM cc_collector_polling_mst AS IM
			WHERE NOT EXISTS (SELECT 1 FROM cc_collector_polling_mst AS EM WHERE EM.collect_method=IM.collect_method AND EM.platform_id=IM.platform_id AND EM.sub_platform_id=$3 AND EM.item_code=IM.item_code AND EM.variable_id=IM.variable_id) AND
			collect_method=$1 AND platform_id=$2;
END
$$ LANGUAGE plpgsql;
SELECT add_cc_collector_polling_mst('SNMP','WINDOWS','AZURE');
SELECT add_cc_collector_polling_mst('SNMP','LINUX','AZURE');

DROP FUNCTION add_cc_collector_polling_mst( varchar, varchar, varchar);
